require "go.ui.Scene"
require "OmokProtocol"

class 'OmokScene' (Scene)

function OmokScene:__init(id)	super(id)
	self:SetupUIObjects()
	self:InitHandler()
	--self:SetMsgHandler(Evt_KeyboardDown, self.OnKeyDown)
end

function OmokScene:OnKeyDown(msg)
	--local keyValue = msg:GetNValue(Evt_KeyboardDown.key.Value)
	--print(keyValue)
end

function OmokScene:Update(elapsed)
end

-- 초기화 함수 
function OmokScene:InitHandler()
	self.editChat.KeyboardDown:AddHandler(self.editChat_KeyboardDown)
	self.btnBoard.MouseLClick:AddHandler(self.siBoard_MouseLClick)
end

-- 채팅 엔터 시
function OmokScene:editChat_KeyboardDown(control, msg)
	if not gameapp.isIn then
		return
	end

	local keyValue = msg:GetValue(Evt_KeyboardDown.key.Value)
	if keyValue == UIConst.KeyEnter then
		local msgChat = Message(Evt_Chat)
		msgChat:SetValue(Evt_Chat.key.chattext, "[" .. gameapp.name .. "] : " .. self.editChat:GetText())
		gameapp:SendToServer(msgChat)
		self.editChat:ClearEdit()
	end
end

-- 보드에 마우스클릭 시
function OmokScene:siBoard_MouseLClick(control, msg)
	local x, y = self:GetMouseState()
	print("x = " .. math.floor(x / 50 - 1))
	print("y = " .. math.floor(y / 50 - 1))
	if x > 0 and x < 700 and y > 0 and y < 700 then
		local msgPut = Message(Evt_Put)
		msgPut:SetValue(Evt_Put.key.x, math.floor(x / 50))
		msgPut:SetValue(Evt_Put.key.y, math.floor(y / 50))
		msgPut:SetValue(Evt_Put.key.color, gameapp.no)
		gameapp:SendToServer(msgPut)
	end
end
require "OmokSceneUIObject"